routes/admin.php
<?php

/*
|--------------------------------------------------------------------------
| Admin Routes
|--------------------------------------------------------------------------
|
| Here is where you can register admin-level routes. Routes in this file
| are protected by auth/login requirements.
|
*/

Route::middleware('admin')->namespace('Admin')->group(function () {

    /**
     * Admin-level homepage/dashboard.
     */
    Route::get('/', 'HomeController@index')->name('home');

    // Testimonials Route
    Route::resource('testimonials', 'TestimonialController');


    // Contact Route
    Route::resource('contacts', 'ContactController');

// setting route
    Route::get('settings' , 'SettingController@index')->name('settings.edit');

    Route::post('settings', 'SettingController@store')->name('settings.store');

    // new fabrication pages
//    Route::get('page/fabrication/list' , 'PageController@listFabrication')->name('fabrication.list');

    Route::resource('fabrications', 'FabricationController');

// slider Route
    Route::resource('sliders', 'SliderController');


    // slide Route
    Route::resource('slides', 'SlideController');

    // floorplan route
    Route::resource('floorplans', 'FloorPlanController');

    Route::post('floorplans/add-items', 'FloorPlanController@addItems');

    // coach model route
    Route::get('models', 'HomeController@models');
    Route::get('models/edit/{id}', 'HomeController@editModel');
    Route::post('models/update/{id}', 'HomeController@updateModel');

    // page route
    Route::get('page/{page}/{tab?}', 'PageController@index');

    Route::post('page/update', 'PageController@update');

    Route::post('page/content/{page}/{key}/delete', 'PageController@deleteContent');

    Route::post('page/content/{page}/{key}/{tab?}/delete', 'PageController@deleteContent');

    // custom reference categories routes
    Route:Route::resource('custom-reference-categories', 'CustomReferenceCategoryController');
    // custom post routes
    Route::get('/custom-posts','CustomPostController@index')->name('customposts.index');

    Route::Post('/custom-posts/slug','CustomPostController@slug')->name('customposts.slug');
    Route::get('/custom-post/create','CustomPostController@create')->name('customposts.create');

    Route::post('/custom-post/store','CustomPostController@store')->name('customposts.store');

    Route::get('/cutom-post/{id}/edit','CustomPostController@edit')->name('customposts.edit');

    Route::post('/custom-post/{id}/update','CustomPostController@update')->name('customposts.update');

    Route::delete('/custom-post/{id}/delete','CustomPostController@delete')->name('customposts.delete');

    Route::get('/custom-reference-category','MegaController@customReferenceCategory')->name('custom-reference-attribute.index');

    Route::get('/custom-reference-category/{id}/edit','MegaController@editCustomReferenceCategory')->name('custom-reference-attribute.edit');

    Route::post('/custom-reference-category/{id}/update','MegaController@updateCustomReferenceCategory')->name('custom-reference-attribute.update');

    /**
     * Users
     */
    //    Route::get('users/{user}/delete', 'UserController@delete')->name('users.delete');
    Route::resource('users', 'UserController');
    Route::resource('members', 'MemberController');
    Route::resource('virtual-tour', 'VirtualTourController'); // ***
//    Route::resource('service-specials', 'ServiceSpecialsController'); // ***
    Route::get('tour-event/payments', 'MemberController@paymentHistory');

    Route::get('{customPostSlug}', 'MegaController@index');
    Route::get('{customPostSlug}/create', 'MegaController@create');
    Route::post('{customPostSlug}/store', 'MegaController@store');
    Route::get('{customPostSlug}/{itemId}/edit', 'MegaController@edit');
    Route::put('{customPostSlug}/{itemId}/update', 'MegaController@update');
    Route::delete('{customPostId}/{itemId}/destroy', 'MegaController@delete');
    Route::post('{customPostId}/{itemId}/{sectionId}/{attributeId}/delete', 'MegaController@deleteDocument');
    Route::get('reference-data-by-selection/{selectedId}/{tableReferencedBy?}/{foreignKey?}', 'MegaController@getReferenceData');
    Route::post('update-sorting-order', 'MegaController@updateSortOrder');

    Route::resource('custom-attributes', 'CustomAttributeController');

});

routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
//
//Route::get('/', function () {
//    return view('welcome');
//});

use App\Mail\NotificationSend;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Mail;

Auth::routes();

Route::get('/', 'HomeController@index')->name('home');
Route::get('/about', 'HomeController@about')->name('about');
Route::get('/model/{coach?}', 'HomeController@models')->name('coach-model');
Route::get('/inventory', 'HomeController@inventory')->name('inventory');
Route::get('/motorcade-club', 'HomeController@motorcadeClub')->name('motorcade-club');
Route::get('/recall-information' , 'HomeController@recallInformation')->name('recall-information');
Route::get('/owner-service' , 'HomeController@ownerService')->name('owner-service');
Route::get('/technical-support', 'HomeController@technicalSupport')->name('technical-support');
//Route::get('/technical-support/search', 'HomeController@technicalSupportSearch')->name('technical-support-search');
Route::get('/information', 'HomeController@information')->name('information');
Route::get('/parts-department', 'HomeController@partsDepartment')->name('parts-department');
Route::get('/remodel-department', 'HomeController@remodelDepartment')->name('remodel-department');
Route::get('/service-department','HomeController@serviceDepartment')->name('service-department');
Route::get('/career','HomeController@career')->name('career');
Route::get('reference-data-by-selection/{selectedId}', 'HomeController@getReferenceData');
Route::get('fabrication/{page}', 'HomeController@getFabrication');

Route::post('/contact', 'HomeController@contactSubmit')->name('contact');

Route::post('/motorcade-member-register', 'Auth\RegisterController@motorcadeMemberRegister')->name('motorcade-member-register')->middleware('guest');
Route::get('/motorcade-member-profile', 'HomeController@motorcadeMemberProfile')->name('motorcade-member-profile');
Route::post('/motorcade-member-profile', 'HomeController@motorcadeMemberUpdate')->name('motorcade-member-update');
Route::get('/motorcade-member-directory/{type}', 'HomeController@motorcadeMemberDirectory')->name('motorcade-member-directory');

# PayPal checkout
Route::get('checkout', 'PaypalController@payWithPayPal')->name('checkout');

# PayPal status callback
Route::get('paypal-payment-status', 'PaypalController@getPaymentStatus')->name('payment-status');


Route::get('send-mail', function (){

    // get the subject of notification email.
    $subject        = 'New Motorcade Member Registration!!';

    // get the body of notification email.
    $contentText    = Auth::user();

    Mail::to(env('MAIL_TO_ADDRESS'))->send(new NotificationSend('member-registration',$contentText, $subject));

});

app/Models/ServiceSpecial.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class ServiceSpecial extends Model
{
    protected $fillable = [
        'image',
        'description',
        'model_id',
        'sort'
    ];

    public function createdBy(){
        return $this->belongsTo(User::class,'created_by');
    }

    public function updatedBy(){
        return $this->belongsTo(User::class,'updated_by');
    }

    public function model(){
        return $this->belongsTo(Model::class,'model_id');
    }

}

app/Http/Controllers/Admin/ServiceSpecialsController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Models\CoachModel;
use App\Models\FloorplanItem;
use App\Models\ServiceSpecial;
use Illuminate\Http\Request;
use App\Models\FloorPlan;
use Illuminate\Support\Facades\Auth;


class ServiceSpecialsController extends Controller
{


    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {
        // fetching all floorplan list
        if ($request->has('model')) {
            $servicespecials = ServiceSpecial::where('model', $request->model)->orderBy('sort')->get();
        } else {
            $servicespecials = ServiceSpecial::orderBy('sort')->get();
        }

        return view('admin.servicespecials.index', compact('servicespecials'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $coachModels = CoachModel::all();
        return view('admin.servicespecials.create',compact('coachModels'));
    }



    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $request->validate([

            'model'             => 'required',
            'tour_url'          => 'required',
            'title'             => 'required',
            'thumb_image'       => 'required|image|mimes:jpeg,png,jpg,svg|max:10480'
        ]);

        $servicespecial = new ServiceSpecial();
        $servicespecial->model = $request->model;
        $servicespecial->tour_url = $request->tour_url;
        $servicespecial->title = $request->title;
        $servicespecial->created_by = Auth::user()->id;


        if ($request->hasFile('thumb_image')) {

            $file = $request->file('thumb_image');
            $filename = time() . '.' . $file->getClientOriginalExtension();
            $path = public_path('img/photo');
            $file->move($path, $filename);
            $servicespecial->thumb_image = 'img/photo/' . $filename;
        }

        $servicespecial->save();

        return redirect()->route('admin.servicespecial.index')->with('success', 'Virtual Tour created successfully');
    }



    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $servicespecial = ServiceSpecial::find($id);

        $coachModels = CoachModel::all();
        if ($servicespecial) {
            return view('admin.servicespecial.edit', compact('virtualtour','coachModels'));
        }
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $request->validate([

            'model'             => 'required',
            'tour_url'          => 'required',
            'title'             => 'required',
        ]);

        $servicespecial = ServiceSpecial::find($id);
        if ($servicespecial) {

            $servicespecial->model = $request->model;
            $servicespecial->tour_url = $request->tour_url;
            $servicespecial->title = $request->title;
            $servicespecial->updated_by = Auth::user()->id;

            if ($request->hasFile('thumb_image')) {

                $file = $request->file('thumb_image');
                $filename = time() . '.' . $file->getClientOriginalExtension();
                $path = public_path('img/photo');
                $file->move($path, $filename);
                $servicespecial->thumb_image = 'img/photo/' . $filename;
            }

            $servicespecial->update();

            return redirect()->route('admin.servicespecial.index')->with('success','virtual tour updated successfully');
        }
    }



    public function destroy($id)
    {
        $serviceSpecial = ServiceSpecial::find($id);

        if($serviceSpecial){

            $serviceSpecial->delete();

            return redirect()->route('admin.servicespecial.index')->with('success','virtual tour deleted successfully');
        }else{
            return redirect()->route('admin.servicespecial.index')->with('error','virtual tour deletion failed');
        }
    }
}

resources/views/admin/servicespecial/create.blade.php
@extends('layouts.admin')
@section('content')
    {!!  _breadcrumbs(['Virtual Tour','Create'])  !!}
    <div class="">
    <div class="row">
        <div class="col-lg-12">
            <div class="page-header">
                <h1>
                    Sepcial Service
                    <small>
                        <i class="ace-icon fa fa-angle-double-right"></i>
                        Create Sepcial Services
                    </small>
                </h1>
            </div>

            <div class="form">
                <form id="validation-form" class="form-horizontal" action="{{ route('admin.virtual-tour.store')}}" method="post" enctype="multipart/form-data">
                        {{ csrf_field() }}
                        <div class="form-group @error('model') has-error   @enderror">
                            <label class="col-sm-3 control-label no-padding-right" for="model"> Model </label>

                            <div class="col-sm-9">
                                <div class="clearfix">
                                    <select id="model" name="model" class="col-xs-10 col-sm-5">
                                        @foreach($coachModels as $model)
                                            <option value="{{ $model->slug }}">{{ $model->title }}</option>
                                        @endforeach
                                    </select>
                                    {{--<input type="text" id="model" placeholder="Model" name="model" class="col-xs-10 col-sm-5" />--}}
                                </div>
                                @error('model')
                                <div id="name-error" class="help-block">{{ $message }}</div>
                                @enderror
                            </div>
                        </div>
                        <div class="form-group  @error('tour_url') has-error   @enderror">
                            <label class="col-sm-3 control-label no-padding-right" for="tour_url"> Tour Url </label>

                            <div class="col-sm-9">
                                <div class="clearfix">
                                    <input type="text" id="tour_url" placeholder="Tour Url" name="tour_url" class="col-xs-10 col-sm-5" />
                                </div>
                                @error('tour_url')
                                <div  class="help-block">{{ $message }}</div>
                                @enderror
                            </div>
                        </div>

                        <div class="space-4"></div>
                        <div class="form-group  @error('title') has-error   @enderror">
                            <label class="col-sm-3 control-label no-padding-right" for="title"> Title </label>

                            <div class="col-sm-9">
                                <div class="clearfix">
                                    <input type="text" id="title" placeholder="Title" name="title" class="col-xs-10 col-sm-5" />
                                </div>
                                @error('title')
                                <div  class="help-block">{{ $message }}</div>
                                @enderror
                            </div>
                        </div>
                        <div class="space-4"></div>

                        <div class="form-group @error('thumb_image') has-error @enderror">
                            <label class="col-sm-3 control-label no-padding-right" for="form-field-1">Thumb Image</label>
                            <div class="col-sm-4">
                            <div class="clearfix">
                                <input class="col-xs-10 col-sm-5 id-input-file-3"  type="file" name="thumb_image"/>
                            </div>
                            @error('thumb_image')
                                <div  class="help-block">{{ $message }}</div>
                            @enderror

                            </div>
                        </div>


                        <div class="clearfix">
                            <div class="col-md-offset-3 col-md-9">
                                <button class="btn btn-info" type="submit">
                                    <i class="ace-icon fa fa-check bigger-110"></i>
                                    Create
                                </button>
                            </div>
                        </div>
                </form>
            </div>
        </div>
    </div>
</div>

@endsection

resources/views/admin/servicespecial/edit.blade.php
@extends('layouts.admin')
@section('content')
    {!!  _breadcrumbs(['Sepcial Service','Update'])  !!}
    <div class="">
    <div class="row">
        <div class="col-lg-12">
            <div class="page-header">
                <h1>
                    Virtual Tour
                    <small>
                        <i class="ace-icon fa fa-angle-double-right"></i>
                        Update Sepcial Services
                    </small>
                </h1>
            </div>

            <div class="form">
                <form id="validation-form" class="form-horizontal" action="{{ route('admin.virtual-tour.update',$virtualtour->id)}}" method="post" enctype="multipart/form-data">
                    {{ csrf_field() }}
                    @method('PATCH')
                    <div class="form-group @error('model') has-error   @enderror">
                        <label class="col-sm-3 control-label no-padding-right" for="model"> Model </label>

                        <div class="col-sm-9">
                            <div class="clearfix">
                                <select id="model" name="model" class="col-xs-10 col-sm-5">
                                    @foreach($coachModels as $model)
                                        <option {{$virtualtour->model == $model->slug ? 'selected' : ''}} value="{{ $model->slug }}">{{ $model->title }}</option>
                                    @endforeach
                                </select>
                                {{--<input type="text" value="{{$floorplan->model}}" id="model" placeholder="Model" name="model" class="col-xs-10 col-sm-5" />--}}
                            </div>
                            @error('model')
                            <div id="name-error" class="help-block">{{ $message }}</div>
                            @enderror
                        </div>
                    </div>
                        <div class="form-group  @error('tour_url') has-error   @enderror">
                            <label class="col-sm-3 control-label no-padding-right" for="tour_url"> Tour Url </label>

                            <div class="col-sm-9">
                                <div class="clearfix">
                                <input type="text" id="tour_url" value="{{$virtualtour->tour_url}}" placeholder="Tour Url" name="tour_url" class="col-xs-10 col-sm-5" />
                                </div>
                                @error('tour_url')
                                <div  class="help-block">{{ $message }}</div>
                                @enderror
                            </div>
                        </div>

                        <div class="space-4"></div>
                        <div class="form-group  @error('title') has-error   @enderror">
                            <label class="col-sm-3 control-label no-padding-right" for="title"> Title </label>

                            <div class="col-sm-9">
                                <div class="clearfix">
                                <input type="text" id="title" value="{{$virtualtour->title}}" placeholder="Title" name="title" class="col-xs-10 col-sm-5" />
                                </div>
                                @error('title')
                                <div  class="help-block">{{ $message }}</div>
                                @enderror
                            </div>
                        </div>
                        <div class="space-4"></div>

                        <div class="form-group @error('thumb_image') has-error @enderror">
                            <label class="col-sm-3 control-label no-padding-right" for="form-field-1">Thumb Image</label>
                            <div class="col-sm-4">
                            <div class="clearfix">
                                <input class="col-xs-10 col-sm-5 id-input-file-3"  type="file" name="thumb_image"/>
                            </div>
                            @error('thumb_image')
                                <div  class="help-block">{{ $message }}</div>
                            @enderror

                            </div>
                            <div class="col-sm-3">
                            @if($virtualtour->thumb_image != '')
                            <div class="col-xs-4">
                                <ul class="ace-thumbnails clearfix">
                                    <li>
                                        <a href="{{ asset($virtualtour->thumb_image) }}" data-rel="colorbox" class="cboxElement">
                                            <img width="150" height="150" alt="150x150" src="{{ asset($virtualtour->thumb_image) }}">
                                        </a>

                                        {{--<div class="tools tools-right">--}}
                                            {{--<a href="#" onclick="removeMedia(this)" data-key="{{ $content->key }}" data-action="{{ url('admin/page/content/' . $content->key .'/delete') }}">--}}
                                                {{--<i class="ace-icon fa fa-times red"></i>--}}
                                            {{--</a>--}}
                                        {{--</div>--}}
                                    </li>
                                </ul>
                            </div>
                            @endif
                            </div>
                        </div>


                        <div class="clearfix">
                            <div class="col-md-offset-3 col-md-9">
                                <button class="btn btn-info" type="submit">
                                    <i class="ace-icon fa fa-check bigger-110"></i>
                                    Update
                                </button>
                            </div>
                        </div>
                </form>
            </div>
        </div>
    </div>
</div>

@endsection

resources/views/admin/servicespecial/index.blade.php
@extends('layouts.admin')
@section('content')
    {!!  _breadcrumbs(['Model', 'Floorplans'])  !!}
    <div class="">
    <div class="row">
        <div class="col-lg-12">
            <div class="page-header">
                <h1>
                    Sepcial Service
                    <small>
                        <i class="ace-icon fa fa-angle-double-right"></i>
                        All Sepcial Service
                    </small>
                </h1>


                <a href="javascript:;" onclick="updateSortOrder()" data-model="virtual_tours" id="sortButton" style="display: none;position: absolute;top: 56px;right: 397px;">
                    <span class="btn btn-warning">Save Order</span>
                </a>

                <a href="javascript:;" onclick="cancelSortOrder()" id="cancelSortButton" style="display: none;position: absolute;top: 56px;right: 320px;">
                    <span class="btn btn-danger">Clear</span>
                </a>

                <a href="{{ url('admin/floorplans/create' . (isset($_GET['model'])? ('?model=' . $_GET['model']) : '') ) }}">
                    <span class="btn btn-success create-button">Create</span>
                </a>

            </div>

            @if (session('success'))
                <div class="alert alert-success">
                    <button type="button" class="close" data-dismiss="alert">
                        <i class="ace-icon fa fa-times"></i>
                    </button>

                    <strong>
                        <i class="ace-icon fa fa-check"></i>
                        Success!
                    </strong>
                    {{ session('success') }}
                    <br>
                </div>
            @endif


            @if(isset($data['filters']) && count($data['filters']))
                <form action="">
                    <select name="filterBy" onchange='this.form.submit()' class="chosen-select form-control filter-select" id="form-field-select-3" data-placeholder="Filter" style="width: 200px;float: right;position: absolute;top: 59px;right: 110px;">
                        <option value="">Select to Filter</option>
                        @foreach($data['filters'] as $index => $filter)
                            <option {{ Request::get('filterBy') == $filter? 'selected' : ''}} value="{{ $filter }}"> {{ ucfirst($index) }}</option>
                        @endforeach
                    </select>

                    <input type="hidden" name="model" value="{{ Request::get('model') }}">
                    <input type="hidden" name="ref" value="{{ Request::get('ref') }}">
                </form>
            @endif


            <div class="all-contacts">
                <table  id="dynamic-table" class="table  table-bordered table-hover">
                        <thead>
                                <tr>
                                    <th>Model</th>
                                    <th>Title</th>
                                    <th>Url</th>
                                    <th>Created By</th>
                                    <th>Actions</th>
                                </tr>
                        </thead>

                        <tbody class="sortable">
                            @foreach ($virtualtours as $virtualtour)
                            <tr class="items" data-item_id="{{ $virtualtour->id }}">
                                <td>{{ $virtualtour->model }}</td>
                                <td>{{ $virtualtour->title }}</td>
                                <td><img style="width:60px;height:60px" src="{{ asset($virtualtour->tour_url) }}" alt=""></td>

                                <td>{{ $virtualtour->createdBy->name }}</td>
                                <td>
                                    <div class="hidden-sm hidden-xs btn-group" style="display:flex">

                                        <a class="btn btn-xs btn-success" href="{{route('admin.virtual-tour.edit', $virtualtour->id) . (isset($_GET['model'])? ('?model=' . $_GET['model']) : '') }}" >
                                            <i class="ace-icon fa fa-pencil bigger-120"></i>
                                        </a>

                                        <form method="post" class="delete_form" action="{{route('admin.virtual-tour.destroy', $virtualtour->id) . (isset($_GET['model'])? ('?model=' . $_GET['model']) : '')}}">
                                            {{csrf_field()}}
                                            <input type="hidden" name="_method" value="DELETE" />
                                            <button type="submit" onclick="return confirm('Are you sure?')" class="btn btn-xs btn-danger" class="tooltip-info" data-rel="tooltip" title="Delete">
                                                    <span class="red">
                                                        <i style="background-color:white" class="ace-icon fa fa-trash-o bigger-120"></i>
                                                    </span>
                                            </button>
                                        </form>
                                    </div>
                                </td>
                            </tr>
                            @endforeach

                        </tbody>
                </table>
            </div>
        </div>
    </div>
</div>

@endsection